image: node:latest
stages:
  - install
  - build
  - test
  - deploy

variables:
  APP_DIRECTORY: "/var/www/html"

cache:
  paths:
    - node_modules/
    - dist/

install:
  stage: install
  script:
    - npm install

build-web:
  stage: build
  script:
    - npm run build

unit-testing:
  stage: test
  script:
    - echo "testing"

integration-testing:
  stage: test
  script:
    - echo "integration testing"

deploy-to-development-server:
  stage: deploy
  image: debian:latest
  before_script:
    - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )'
    - eval $(ssh-agent -s)
    - ssh-add <(echo "$SSH_PRIVATE_KEY")
    - mkdir -p ~/.ssh
    - '[[ -f /.dockerenv ]] && ssh-keyscan -H "$SERVER_DEVELOPMENT" > ~/.ssh/known_hosts'
  script:
    - scp -r dist/* ubuntu@$SERVER_DEVELOPMENT:$APP_DIRECTORY/
